/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoEncryptionDesede]のクラス
 */
package blanco.encryption.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.encryption.task.valueobject.BlancoEncryptionDesedeBatchProcessInput;

/**
 * Apache Antタスク [BlancoEncryptionDesede]のクラス。
 *
 * トリプルDESのためのAntTaskです。<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.encryption.task]にBlancoEncryptionDesedeBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blancoencryptiondesede&quot; classname=&quot;blanco.encryption.task.BlancoEncryptionDesedeTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoEncryptionDesedeTask extends Task {
    /**
     * トリプルDESのためのAntTaskです。
     */
    private BlancoEncryptionDesedeBatchProcessInput fInput = new BlancoEncryptionDesedeBatchProcessInput();

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final String arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public String getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[inputDir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * 入力ディレクトリ名を指定します。<br>
     *
     * @param arg セットしたい値
     */
    public void setInputDir(final String arg) {
        fInput.setInputDir(arg);
    }

    /**
     * Antタスクの[inputDir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * 入力ディレクトリ名を指定します。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getInputDir() {
        return fInput.getInputDir();
    }

    /**
     * Antタスクの[outputDir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力ディレクトリ名を指定します。<br>
     *
     * @param arg セットしたい値
     */
    public void setOutputDir(final String arg) {
        fInput.setOutputDir(arg);
    }

    /**
     * Antタスクの[outputDir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力ディレクトリ名を指定します。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getOutputDir() {
        return fInput.getOutputDir();
    }

    /**
     * Antタスクの[password]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     * パスワードを指定します。<br>
     *
     * @param arg セットしたい値
     */
    public void setPassword(final String arg) {
        fInput.setPassword(arg);
    }

    /**
     * Antタスクの[password]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * パスワードを指定します。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getPassword() {
        return fInput.getPassword();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoEncryptionDesedeTask begin.");

        // 項目番号[1]、アトリビュート[inputDir]は必須入力です。入力チェックを行います。
        if (getInputDir() == null) {
            throw new BuildException("アトリビュート[inputDir]が設定されていません。処理を中断します。");
        }
        // 項目番号[2]、アトリビュート[outputDir]は必須入力です。入力チェックを行います。
        if (getOutputDir() == null) {
            throw new BuildException("アトリビュート[outputDir]が設定されていません。処理を中断します。");
        }
        // 項目番号[3]、アトリビュート[password]は必須入力です。入力チェックを行います。
        if (getPassword() == null) {
            throw new BuildException("アトリビュート[password]が設定されていません。処理を中断します。");
        }

        if ("true".equals(getVerbose())) {
            System.out.println("- verbose:[true]");
            System.out.println("- inputDir:[" + getInputDir() + "]");
            System.out.println("- outputDir:[" + getOutputDir() + "]");
            System.out.println("- password:[" + getPassword() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            if (new BlancoEncryptionDesedeBatchProcess().execute(fInput) != BlancoEncryptionDesedeBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if ("true".equals(getVerbose())) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
